<%@ Page Language="VB" AutoEventWireup="false" EnableViewState="false" %>

<%@ Import Namespace="System.IO" %>

<script runat="server">
	'This variable specifies relative path to the folder, where the gallery with uploaded files is located.
	'Do not forget about the slash in the end of the folder name.
	Private galleryPath As String = "../Gallery/"	
	
	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

		'Delete all previously uploaded files.

		'Delete source files.
		Dim dir As New DirectoryInfo(Server.MapPath(galleryPath))
		For Each file As FileInfo In dir.GetFiles()
			file.Delete()
		Next

		'Delete thumbnails.
		dir = New DirectoryInfo(Server.MapPath(galleryPath) & "/Thumbnails")
		For Each file As FileInfo In dir.GetFiles()
			file.Delete()
		Next
		
		'NOTE: If you do not want to delete previously uploaded files, just 
		'remove or comment out the code above.        

	End Sub
</script>

<!--BEGIN-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader</title>

	<script type="text/javascript" src="../iuembed.js"></script>

	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		This sample application demonstrates how to make Image Uploader to upload files
		asynchronously through several concurrent HTTP connections. In addition this demo
		highlights the following features:</p>
	<ul>
		<li>Advanced details view (with progress bar inside the upload pane).</li>
		<li>Automatic recovery of broken connection.</li>
		<li>Upload thumbnail along with a source file.</li>
		<li>Upload to several URLs.</li>
	</ul>
	<fieldset>
		<legend>Note</legend>This demo application <strong>deletes all previously uploaded files</strong>.
		Keep in mind that it is a feature of this demo, not of Image Uploader itself. If
		you <strong>do not want to delete uploaded files</strong>, you should modify the
		upload processing page specified by the <strong>Action</strong> parameter.
	</fieldset>

	<script type="text/javascript">
//<![CDATA[	

function ImageUploader1_BeforeUpload() {
	getImageUploader("ImageUploader1").setButtonStopText("Stop");
	needToHideButtonStop = false;
}

function ImageUploader1_Progress(Status, Progress, ValueMax, Value, StatusText) {
	//Stop button should be displayed only during the upload process. If the upload 
	//completed (either successfully or not), the button should be hidden.
	needToHideButtonStop = (Status=="COMPLETE" || Status=="ERROR" || Status=="CANCEL");
}

//Create JavaScript object that will embed Image Uploader to the page.
var iu = new ImageUploaderWriter("ImageUploader1", 600, 400);

//For ActiveX control full path to CAB file (including file name) should be specified.
iu.activeXControlCodeBase = "../ImageUploader5.cab";
iu.activeXControlVersion = "5,0,41,0";

//For Java applet only path to directory with JAR files should be specified (without file name).
iu.javaAppletJarFileName = "ImageUploader5.jar";
iu.javaAppletCodeBase = "../";
iu.javaAppletCached = true;
iu.javaAppletVersion = "5.0.41.0";

iu.showNonemptyResponse = "off";

//Set and configure advanced details view.
iu.addParam("PaneLayout", "OnePane");
iu.addParam("UploadView", "AdvancedDetails");
iu.addParam("AdvancedDetailsPreviewThumbnailSize", "40");

//Configure License Keys
iu.addParam("LicenseKey", "71050-49A8A-00000-08302-413E7;72050-49A8A-00000-076AD-199A9");


//Configure thumbnail settings.
iu.addParam("UploadThumbnail1FitMode", "Fit");
iu.addParam("UploadThumbnail1Width", "120");
iu.addParam("UploadThumbnail1Height", "120");
iu.addParam("UploadThumbnail1JpegQuality", "60");

//Configure upload settings.
iu.addParam("FilesPerOnePackageCount", "1");
iu.addParam("AutoRecoverMaxTriesCount", "5");
iu.addParam("AutoRecoverTimeOut", "10000");
iu.addParam("MaxConnectionCount", "3");

//Set several URLs files should be uploaded to. In a real life most likely
//you will specify URLs to different servers, however in this demo the single
//server and page is used for brevity.
iu.addParam("Action", "upload.aspx?handlerId=1;upload.aspx?handlerId=2;upload.aspx?handlerId=3");

//Configure URL where to redirect after upload.
iu.addParam("RedirectUrl", "gallery.aspx");

//Configure miscellaneous settings.
iu.addParam("ShowDebugWindow", "true");
iu.addParam("BackgroundColor", "#ffffcd");
iu.addParam("ShowContextMenu", "false");

//Concurrent upload feature and advanced details view are not supported in Java version yet. 
//This way we need to get Java version working in standard mode (sequential upload with standard
//progress dialog).
if (iu.getControlType() == "ActiveX"){
	iu.addParam("SilentMode", "true");
	var needToHideButtonStop = false;

	iu.addEventListener("BeforeUpload", "ImageUploader1_BeforeUpload");
	iu.addEventListener("Progress", "ImageUploader1_Progress");

	//Use timer to check whether to hide the Stop button. It allows to avoid the button flickering.
	window.setInterval("if (needToHideButtonStop) {getImageUploader('ImageUploader1').setButtonStopText(''); needToHideButtonStop = false;}", 500);
}

//Tell Image Uploader writer object to generate all necessary HTML code to embed 
//Image Uploader to the page.
iu.writeHtml();
//]]>
	</script>

</body>
</html>
<!--END-->