<%@ Page Language="VB" AutoEventWireup="false" Debug="true" ValidateRequest="false" %>

<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>

<script runat="server">
	'This variable specifies relative path to the folder, where the gallery with uploaded files is located.
	'Do not forget about the slash in the end of the folder name.
	Private galleryPath As String = "../Gallery/"

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

		'Get the source file and save it to disk. 
        
		'NOTE: Since each file is uploaded in a separate request (because 
		'FilesPerOnePackageCount param equals to 1), you should work only 
		'with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc). 
		Dim sourceFile As HttpPostedFile = Request.Files("SourceFile_1")

		Dim fileName As String = GetSafeFileName(sourceFile.FileName)
		sourceFile.SaveAs(Server.MapPath(galleryPath & fileName))

		'Get the thumbnail and save it to disk.
		Request.Files("Thumbnail1_1").SaveAs(Server.MapPath(galleryPath & "Thumbnails/" & fileName & ".jpg"))

		'Get file info and save it to XML file.
		'NOTE: In this demo this file is used by different upload threads asynchronously. That's why 
		'it is necessary to synchronize access to this file. 	
		SyncLock (Application) 'TODO: Use synchronization in more narrow scope

			Dim descriptionsPath As String = Server.MapPath(galleryPath & "Descriptions.xml")

			'Create XML file which will keep information about files (image dimensions, description, etc). 
			'XML is used solely for brevity. In real-life application most likely you will use database instead.
			Dim descriptions As New XmlDocument()
			If (File.Exists(descriptionsPath)) Then
				descriptions.Load(descriptionsPath)
			Else
				descriptions.AppendChild(descriptions.CreateElement("files"))
			End If

			Dim xmlFile As XmlElement = descriptions.CreateElement("file")
			xmlFile.SetAttribute("name", fileName)
			xmlFile.SetAttribute("width", Request.Form("Width_1"))
			xmlFile.SetAttribute("height", Request.Form("Height_1"))
			xmlFile.SetAttribute("handlerUrl", Request.Url.PathAndQuery)

			descriptions.DocumentElement.AppendChild(xmlFile)

			descriptions.Save(descriptionsPath)
			
		End SyncLock
	End Sub

	'This method verifies whether file with such name already exists 
	'and if so, construct safe filename name (to avoid collision).
	Private Function GetSafeFileName(ByVal fileName As String) As String
		
		Dim newFileName As String = fileName
		Dim j As Integer = 1
		While (File.Exists(Server.MapPath(galleryPath & newFileName)))
			newFileName = j & "_" & fileName
			j += 1
		End While
		
		Return newFileName
	
	End Function
</script>

