<%@ page language='java' import='java.io.*,java.util.*,javax.servlet.*,javax.servlet.http.*,org.apache.commons.fileupload.*,org.apache.commons.codec.binary.*'%>
<%!
//This variable specifies relative path to the folder, where the gallery with uploaded files is located.
//Do not forget about the slash in the end of the folder name.
String galleryPath = "/Gallery/";

String absGalleryPath;
String absTempPath;

//This method verifies whether file with such name already exists
//and if so, construct safe filename name (to avoid collision).
String getSafeFileName(String fileName) {
    String newFileName = fileName;
    File file = new File(absGalleryPath + File.separator + newFileName);
    int j = 1;
    while (file.exists()) {
	newFileName = j + "_" + fileName;
	file = new File(absGalleryPath + File.separator + newFileName);
	j = j + 1;
    }
    return newFileName;
}

private void deleteFiles(String path) {
    File dir = new File(path);

    String[] dirList = dir.list();
    for (int i = 0; i < dirList.length; i++) {
	File file = new File(path + File.separator + dirList[i]);
	if (file.isFile()) {
	    file.delete();
	}
    }
}
%>
<%
//Process request.
ServletContext context = getServletContext();
absGalleryPath = context.getRealPath(galleryPath);
absTempPath = context.getRealPath(galleryPath + "/Temp");

//Process upload.
DiskFileUpload fileUpload = new DiskFileUpload();
//Set maximum size before a FileUploadException will be thrown.
fileUpload.setSizeMax(100000000);
//Set maximum size that will be stored in memory.
fileUpload.setSizeThreshold(4096);
//Set the location for saving data that is larger than getSizeThreshold().
fileUpload.setRepositoryPath(absTempPath);

//Get uploaded files.
List listFileItems = fileUpload.parseRequest(request);

//Put them in hash table for fast access.
Hashtable fileItems = new Hashtable();

for (int i = 0; i < listFileItems.size(); i++) {
    FileItem fileItem = (FileItem)(listFileItems.get(i));
    fileItems.put(fileItem.getFieldName(), fileItem);
}

//Get the source file.
//NOTE: Since each file is uploaded in a separate request (because
//FilesPerOnePackageCount param equals to 1), you should work only
//with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc).
FileItem sourceFileItem = (FileItem) fileItems.get("SourceFile_1");

//Verify upload integrity. To do it, get the source file, compute hash value for it,
//and compare the result with the hash value calculated by Image Uploader.

//NOTE: In real-life application a single hash method is typically enough.

//Check if this value is actually uploaded.
if (fileItems.containsKey("HashCodeSHA_1") && fileItems.containsKey("HashCodeMD5_1")){
    //Compute SHA1 and MD5 hashes for posted files.
    java.security.MessageDigest sha1 = java.security.MessageDigest.getInstance("SHA");
    java.security.MessageDigest md5 = java.security.MessageDigest.getInstance("MD5");
    InputStream inputStream= sourceFileItem.getInputStream();
    byte[] buffer = new byte[10000];
    while(true){
	int c = inputStream.read(buffer);
	if(c < 0) {
	    break;
	}
	sha1.update(buffer, 0, c);
	md5.update(buffer, 0, c);
    }
    
    String actualSHA1Hash = new String(Base64.encodeBase64(sha1.digest()));
    String actualMD5Hash = new String(Base64.encodeBase64(md5.digest()));
    
    //Get posted SHA1 hash.
    String postedSHA1Hash = ((FileItem) fileItems.get("HashCodeSHA_1")).getString();
    
    //If the result differs from the uploaded one, the upload should be interpreted as corrupted.
    if (!postedSHA1Hash.equals(actualSHA1Hash)) {
	response.sendError(HttpServletResponse.SC_BAD_REQUEST);
	return;
    }
    
    //Get posted MD5 hash.
    String postedMD5Hash = ((FileItem) fileItems.get("HashCodeMD5_1")).getString();
    
    //If the result differs from the uploaded one, the upload should be interpreted as corrupted.
    if (!postedMD5Hash.equals(actualMD5Hash)) {
	response.sendError(HttpServletResponse.SC_BAD_REQUEST);
	return;
    }
}


//If we reach this line, it means that file was not corrupted during upload.
//In this case we should save it to disk.

//Before saving uploaded files let's delete previously uploaded items.
//
//In this code sample each file is uploaded with a separate request. It means that this
//page will be called for each file individually (rather than once for all files). Therefore
//we need a way to determine whether this page is called for new upload session or not.
//
//To do it we check a PackageIndex POST field which returns a number of the request in the upload session.
//If it is the very first package we should delete all files we uploaded before.
//Otherwise, previously uploaded files belong to the same upload session and we should not delete them.
int packageIndex = Integer.parseInt(((FileItem) fileItems.get("PackageIndex")).getString());

if (packageIndex == 0) {
    //Delete source files.
    deleteFiles(absGalleryPath);
}

//NOTE: If you do not want to delete previously uploaded files, just
//remove or comment out the code above.

//Save the uploaded file to disk.
String fileName = getSafeFileName(new File(sourceFileItem.getName()).getName());
File sourceFile = new File(absGalleryPath + File.separator + fileName);
sourceFileItem.write(sourceFile);
%>