#!/usr/local/bin/python

import cgi
import cgitb; cgitb.enable()
import os
import time
import xml.dom
import xml.dom.minidom

try: # Windows needs stdio set for binary mode.
	import msvcrt
	msvcrt.setmode ( 0, os.O_BINARY ) # stdin  = 0
	msvcrt.setmode ( 1, os.O_BINARY ) # stdout = 1
except ImportError:
	pass
	

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
galleryPath = "../Gallery/"

def print_html ():
	print "Content-Type: text/html"
	print
	print

def save_uploaded_files ():
	absGalleryPath = os.path.abspath( galleryPath )
	absThumbnailsPath = os.path.join( absGalleryPath, "Thumbnails" )
	
	form = cgi.FieldStorage()	
	

	#Get the source file and save it to disk. 
	#
	#NOTE: Since each file is uploaded in a separate request (because 
	#FilesPerOnePackageCount param equals to 1), you should work only 
	#with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc). 
	sourceFile = form["SourceFile_1"];
	if not sourceFile.file:	
		return
	
	fileName = get_safe_file_name( sourceFile.filename )			
	f = open ( os.path.join( absGalleryPath, fileName ), 'wb' )
	while 1:
		chunk = sourceFile.file.read( 10000 )
		if not chunk: 
			break	
		f.write( chunk )
	f.close()
		
	#Get the thumbnail and save it to disk.		
	thumbnail1File = form["Thumbnail1_1"];
	if not thumbnail1File.file:
		return
		
	f = open ( os.path.join( absThumbnailsPath, fileName + ".jpg" ), 'wb' )
	while 1:
		chunk = thumbnail1File.file.read( 10000 )
		if not chunk: 
			break	
		f.write( chunk )
	f.close()

	#Get file info and save it to XML file.
	#NOTE: In this demo this file is used by different upload threads asynchronously. That's why 
	#it is necessary to synchronize access to this file. 
	
	descriptionsLockPath = os.path.join( os.path.abspath( galleryPath ), "Descriptions.lck" )	
	#Try to open lock file.
	lockf = open ( descriptionsLockPath, 'w' )
	
	try:
		import portalocker
		portalocker.lock( lockf, portalocker.LOCK_EX )
	except ImportError:
		pass
	
	descriptionsPath = os.path.join( os.path.abspath( galleryPath ), "Descriptions.xml" )
	
	#Create XML file which will keep information about files (image dimensions, description, etc). 
	#XML is used solely for brevity. In real-life application most likely you will use database instead.
	if os.path.exists( descriptionsPath ):
		descriptions = xml.dom.minidom.parse( os.path.join( os.path.abspath( galleryPath ), "Descriptions.xml" ) )
	else:
		domImplementation = xml.dom.getDOMImplementation()
		descriptions = domImplementation.createDocument( "", "files", None )
	
	#Save file info.
	xmlFile = descriptions.createElement( "file" )
	xmlFile.setAttribute( "name", fileName )
	xmlFile.setAttribute( "width", form.getfirst( "Width_1", "0" ) );
	xmlFile.setAttribute( "height", form.getfirst( "Height_1", "0" ) );
	xmlFile.setAttribute( "handlerUrl", os.environ["SCRIPT_NAME"] + "?" + os.environ["QUERY_STRING"]);	
	descriptions.documentElement.appendChild( xmlFile );

	descriptionsFile = open( os.path.join( absGalleryPath, "Descriptions.xml" ), "w" )
	descriptionsFile.write( descriptions.toxml() )
	descriptionsFile.close()

	#Release lock file.
	lockf.close()

#This method verifies whether file with such name already exists 
#and if so, construct safe filename name (to avoid collision).
def get_safe_file_name( fileName ):
	fileName = os.path.basename( fileName )
	newFileName = fileName
	j = 1
	while os.path.exists( os.path.join( os.path.abspath( galleryPath ), newFileName ) ):
		newFileName = str( j ) + "_" + fileName
		j = j + 1
	return newFileName

save_uploaded_files()

print_html()