#!/usr/local/bin/python

import cgi
import cgitb; cgitb.enable()
import os
import xml.dom
import xml.dom.minidom

try: # Windows needs stdio set for binary mode.
	import msvcrt
	msvcrt.setmode ( 0, os.O_BINARY ) # stdin  = 0
	msvcrt.setmode ( 1, os.O_BINARY ) # stdout = 1
except ImportError:
	pass

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
galleryPath = "../Gallery/"

def print_html ():
	print "Content-Type: text/html"
	print
	print

def save_uploaded_files ():
	absGalleryPath = os.path.abspath( galleryPath )
	absThumbnailsPath = os.path.join( absGalleryPath, "Thumbnails" )
	
	form = cgi.FieldStorage()	
	
	#First of all, clear files and data uploaded at previous time.
	
	#In this code sample each file is uploaded with a separate request. It means that this 
	#page will be called for each file individually (rather than once for all files). Therefore
	#we need a way to determine whether this page is called for new upload session or not.
	#
	#To do it we check a PackageIndex POST field which returns a number of the request in the upload session.
	#If it is the very first package we should delete all files and thumbnails we uploaded before. 
	#Otherwise, previously uploaded files belong to the same upload session and we should not delete them. 	
	packageIndex = int( form.getfirst( "PackageIndex", "0" ) );
	if packageIndex == 0:	
		#Delete source files.		
		for fileName in os.listdir( absGalleryPath ):	
			filePath = os.path.join( absGalleryPath, fileName )
			if not os.path.isdir( filePath ):
				os.remove( filePath )
		
		#Delete thumbnails.
		for fileName in os.listdir( absThumbnailsPath ):	
			filePath = os.path.join( absThumbnailsPath, fileName )
			if not os.path.isdir( filePath ):			
				os.remove( filePath )

	#NOTE: If you do not want to delete previously uploaded files, just 
	#remove or comment out the code above.

    #Create XML file which will keep information about files (image dimensions, description, etc). 
    #XML is used solely for brevity. In real-life application most likely you will use database instead.
    #
	#Check whether it is new upload session or not. If yes, the description file is cleared, otherwise
    #information about new files should be appended to existing one.
	if packageIndex == 0:
		domImplementation = xml.dom.getDOMImplementation()
		descriptions = domImplementation.createDocument( "", "files", None )
	else:
		descriptions = xml.dom.minidom.parse( os.path.join( os.path.abspath( galleryPath ), "Descriptions.xml" ) )			

	#Get source file and save it to disk. Since we upload only one file per request,
	#we should get all upload items with index = 1 only.
	sourceFile = form["SourceFile_1"];
	if not sourceFile.file:	
		return
	
	fileName = get_safe_file_name( sourceFile.filename )			
	f = open ( os.path.join( absGalleryPath, fileName ), 'wb' )
	while 1:
		chunk = sourceFile.file.read( 10000 )
		if not chunk: 
			break	
		f.write( chunk )
	f.close()
		
	#Get the thumbnail and save it to disk.		
	thumbnail1File = form["Thumbnail1_1"];
	if not thumbnail1File.file:
		return
		
	f = open ( os.path.join( absThumbnailsPath, fileName + ".jpg" ), 'wb' )
	while 1:
		chunk = thumbnail1File.file.read( 10000 )
		if not chunk: 
			break	
		f.write( chunk )
	f.close()

	#Save file info.
	xmlFile = descriptions.createElement( "file" )
	xmlFile.setAttribute( "name", fileName )
	xmlFile.setAttribute( "width", form.getfirst( "Width_1", "0" ) );
	xmlFile.setAttribute( "height", form.getfirst( "Height_1", "0" ) );
	descriptions.documentElement.appendChild( xmlFile );

	descriptionsFile = open( os.path.join( absGalleryPath, "Descriptions.xml" ), "w" )
	descriptionsFile.write( descriptions.toxml() )
	descriptionsFile.close()

#This method verifies whether file with such name already exists 
#and if so, construct safe filename name (to avoid collision).
def get_safe_file_name( fileName ):
	fileName = os.path.basename( fileName )
	newFileName = fileName
	j = 1
	while os.path.exists( os.path.join( os.path.abspath( galleryPath ), newFileName ) ):
		newFileName = str( j ) + "_" + fileName
		j = j + 1
	return newFileName

save_uploaded_files()

print_html()