#!/usr/local/bin/python

import cgi
import cgitb; cgitb.enable()
import urllib
import os
import xml.dom.minidom

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
galleryPath = "../Gallery/"

HTML_TEMPLATE = """<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader - Uploaded Files</title>
	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		<a href="index.py">Upload New Files</a>
	</p>
	
	<p>
        Total source file size: <strong>%(totalSourceFileSize)s kb</strong><br />
        Total uploaded file size: <strong><span style="color:%(totalUploadedFileSizeColor)s">%(totalUploadedFileSize)s</span> kb</strong><br />
	</p>
    
	<table width="100%%">
		%(rows)s
	</table>
</body>
</html>"""

FILE_INFO_TEMPLATE = """<td>
<a href="%(filePath)s" target="_blank">
<img src="%(thumbnailPath)s" alt="%(fileName)s" />
</a>
<br />
<br />
<b>Name:</b>
%(fileName)s
<br />
<b>Dimensions:</b>
%(width)s
x
%(height)s
</td>"""

def print_html ():
	print "Content-Type: text/html"
	print
	
	descriptions = xml.dom.minidom.parse( os.path.join( os.path.abspath( galleryPath ), "Descriptions.xml" ) )

	colCount = 4	
	
	rows = ""

	for i in range( descriptions.documentElement.childNodes.length ):
		xmlFile = descriptions.documentElement.childNodes[i]
				
		if i % colCount == 0:
			rows = rows + "<tr>"
		
		fileName = xmlFile.getAttribute( "name" )	
		rows = rows + FILE_INFO_TEMPLATE % {"fileName" : fileName, 
			"filePath" : galleryPath + urllib.quote( fileName ), 
			"thumbnailPath" : galleryPath + "Thumbnails/" + urllib.quote( fileName ) + ".jpg", 
			"width" : cgi.escape(xmlFile.getAttribute( "width" ) ), 
			"height" : cgi.escape(xmlFile.getAttribute( "height" ) ) }

		if ( ( i + 1 ) % colCount == 0 ) or ( i == descriptions.documentElement.childNodes.length - 1 ):
			rows = rows + "</tr>"
	
	totalSourceFileSize = int( descriptions.documentElement.getAttribute( "totalSourceFileSize" ) )
	totalUploadedFileSize = int( descriptions.documentElement.getAttribute( "totalUploadedFileSize" ) )

	if totalSourceFileSize > totalUploadedFileSize:
	    totalUploadedFileSizeColor = "blue"
	else:
	    totalUploadedFileSizeColor = "red"		
	
	print HTML_TEMPLATE % {"rows" : rows, 
	    "totalSourceFileSize" : totalSourceFileSize,
	    "totalUploadedFileSize" : totalUploadedFileSize, 
	    "totalUploadedFileSizeColor" : totalUploadedFileSizeColor }

print_html()