#!/usr/bin/env ruby

require 'cgi'
require 'rexml/document'

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
$galleryPath = "../Gallery/"

rows = ""

HTML_TEMPLATE = <<HTMLEND
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader - Uploaded Files</title>
	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		<a href="index.rb">Upload New Files</a>
	</p>
    <table cellspacing="0" rules="all" border="1" style="border-collapse:collapse;">
        <tr style="background-color:Gainsboro;font-weight:bold;">
            <td>File Name</td>
            <td>Size in Bytes</td>
            <td>Extension</td>
            <td>Last Write Time</td>
        </tr>    
        %s
	</table>
</body>
</html>
HTMLEND

FILE_INFO_TEMPLATE = <<HTMLEND
<tr>
<td><a href="%s" target="_blank">%s</a></td>
<td>%s</td>
<td>%s</td>
<td>%s</td>
</tr>
HTMLEND

def print_html()
	print "Content-Type: text/html\r\n\r\n"

	$absGalleryPath = File.expand_path($galleryPath)

	rows = ""

	Dir.foreach($absGalleryPath) {|fileName|
		filePath = File.join($absGalleryPath, fileName)
		if File.ftype(filePath) == "file" then
			#Get file extension
			fn = fileName.split( "." )
			if fn.length > 1 then
				fileExt = "." + fn.last
			else
				fileExt = ""
			end

			rows << FILE_INFO_TEMPLATE % [$galleryPath + encode_file_name(fileName), \
			CGI.escapeHTML(fileName), \
			File.size(filePath), \
			CGI.escapeHTML(fileExt), \
			File.mtime(filePath)]
		end
	}

	printf HTML_TEMPLATE, rows
end

def encode_file_name(value)
	return CGI.escape(value).gsub(/\+/, "%20")
end

print_html()